{-
Copyright (C) 2018-2022, Oscar Leijendekker.

This file is part of the Planck Payments wallet issuer backend.

The Planck Payments wallet issuer backend is free software: you can
redistribute it and/or modify it under the terms of the GNU Affero General
Public License as published by the Free Software Foundation, either version 3
of the License, or (at your option) any later version.

The Planck Payments wallet issuer backend is distributed in the hope that it
will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero General
Public License for more details.

You should have received a copy of the GNU Affero General Public License along
with The Planck Payments wallet issuer backend. If not, see 
<https://www.gnu.org/licenses/>.
-}

{-# LANGUAGE NoImplicitPrelude #-}

module Crypto.KeyManagement (PrivateKey, PublicKey, readPublicKeyPEM, writePublicKeyPEM, getPrivateKey, getPublicKey, getPublicKeyPEM) where

import Prelude

import Crypto.PubKey.RSA (PrivateKey, PublicKey)
import Data.PEM (pemParseBS, pemContent, pemWriteBS, PEM(PEM))
import Data.X509 (PubKey(PubKeyRSA), PrivKey(PrivKeyRSA))
import Data.X509.File (readKeyFile)
import Data.ASN1.Types (fromASN1, toASN1)
import Data.ASN1.Encoding (decodeASN1', encodeASN1')
import Data.ASN1.BinaryEncoding (DER(DER))

import qualified Data.ByteString as BS
import qualified Data.ByteString.Lazy as LBS
import Data.Bifunctor (first)

getPrivateKey :: IO PrivateKey
getPrivateKey =
  do
    privateKeys <- readKeyFile "private.pem"
    case privateKeys of
      [PrivKeyRSA privateKey] -> return privateKey
      _ -> fail "private key PEM must contain exactly 1 private RSA key"


getPublicKey :: IO PublicKey
getPublicKey =
  BS.readFile "public.pem" >>= (either fail return . readPublicKeyPEM)


getPublicKeyPEM :: IO LBS.ByteString
getPublicKeyPEM = do
  LBS.readFile "public.pem"


-- should use custom error rather than String, and preferably something like MonadFail
-- | reads a public key from PEM format (e.g. as generated by OpenSSL)
readPublicKeyPEM :: BS.ByteString -> Either String PublicKey
readPublicKeyPEM bs = do
  pems <- pemParseBS bs
  pem <- case pems of
    pem:[] -> return pem
    _ -> Left "PEM files for public keys must have exactly 1 entry"
  asn1s <- first show $ decodeASN1' DER $ pemContent pem
  (pubkey, _) <- fromASN1 asn1s
  case pubkey of
    PubKeyRSA publicKey -> return publicKey
    _ -> Left "Public Key must be an RSA key"

-- | Writes a public key in PEM format
writePublicKeyPEM :: PublicKey -> BS.ByteString
writePublicKeyPEM publicKey =
  let
    asn1s = toASN1 (PubKeyRSA publicKey) []
    byteString = encodeASN1' DER asn1s
    pem = PEM "PUBLIC KEY" [] byteString
  in
    pemWriteBS pem
